<?php

require_once 'config.php';

//MySQL server and database
$filename = 'db-backup ' . date("Y-m-d H-i", time()) . '.sql';

backDb(SERVERNAME, USERNAME, PASSWORD, DB_NAME, '*', $filename);

// ارسال فایل
$response = sendBackupToTelegram($filename, $admins[0], $token);
if ($response) {
    echo "بکاپ با موفقیت ارسال شد.";
    unset($filename);
} else {
    echo "خطا در ارسال بکاپ.";
}

// ارسال فایل بکاپ به تلگرام
function sendBackupToTelegram($filePath, $chatId, $token)
{
    $url = "https://api.telegram.org/bot$token/sendDocument";
    $postFields = [
        'chat_id' => $chatId,
        'document' => new CURLFile(realpath($filePath)),
    ];

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $postFields);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

    $response = curl_exec($ch);
    curl_close($ch);

    return $response;
}



function backDb($host, $user, $pass, $dbname, $tables, $file_name){
    //make db connection
    $conn = new mysqli($host, $user, $pass, $dbname);
    if ($conn->connect_error) {
        die("Connection failed: " . $conn->connect_error);
    }

    //get all of the tables
    if($tables == '*'){
        $tables = array();
        $sql = "SHOW TABLES";
        $query = $conn->query($sql);
        while($row = $query->fetch_row()){
            $tables[] = $row[0];
        }
    }
    else{
        $tables = is_array($tables) ? $tables : explode(',',$tables);
    }

    //getting table structures
    $outsql = '';
    foreach ($tables as $table) {

        // Prepare SQLscript for creating table structure
        $sql = "SHOW CREATE TABLE $table";
        $query = $conn->query($sql);
        $row = $query->fetch_row();

        $outsql .= "\n\n" . $row[1] . ";\n\n";

        $sql = "SELECT * FROM $table";
        $query = $conn->query($sql);

        $columnCount = $query->field_count;

        // Prepare SQLscript for dumping data for each table
        for ($i = 0; $i < $columnCount; $i ++) {
            while ($row = $query->fetch_row()) {
                $outsql .= "INSERT INTO $table VALUES(";
                for ($j = 0; $j < $columnCount; $j ++) {
                    $row[$j] = $row[$j];

                    if (isset($row[$j])) {
                        $outsql .= '"' . $row[$j] . '"';
                    } else {
                        $outsql .= '""';
                    }
                    if ($j < ($columnCount - 1)) {
                        $outsql .= ',';
                    }
                }
                $outsql .= ");\n";
            }
        }

        $outsql .= "\n"; 
    }

    // Save the SQL script to a backup file
    $fileHandler = fopen($file_name, 'w+');
    fwrite($fileHandler, $outsql);
    fclose($fileHandler);

}