<?php

use chillerlan\QRCode\{QRCode, QROptions};
use chillerlan\QRCode\Common\EccLevel;
use chillerlan\QRCode\Output\{QROutputAbstract, QROutputInterface};

require_once 'vendor/autoload.php';

require_once 'config.php';
require_once 'xuiapi.php';
require_once 'functions.php';
require_once 'jdf.php';


function sqi($value)
{
    global $conn;
    $value = @trim($value);
    return mysqli_real_escape_string($conn, $value);
}


if (isset($_POST['config'])) {
    $_POST['config'] = sqi($_POST['config']);
    if ($_POST['config'] == '') {
        $message =  'کانفیگ ارسالی اشتباه است لطفا پس از بررسی مجدد کد را ارسال کنید';
    }
    if (substr($_POST['config'], 0, 8) === "vmess://") {
        // کانفیگ یک کانفیگ VMess است
        $protocol = "vmess";
        $is_v2ray = 1;
        @$config = json_decode(base64_decode(substr($_POST['config'], 8)), true);
        @$address   = $config['add'];
        @$port      = $config['port'];
        @$client_id = $config['id'];
    } elseif (substr($_POST['config'], 0, 8) === "vless://") {
        // کانفیگ یک کانفیگ VLESS است
        $protocol = "vless";
        $is_v2ray = 1;
        @$config = substr($_POST['config'], 8);
        @$address   = explode(':', explode('@', $config)[1])[0];
        @$port      = explode(':', explode('?', $config)[0])[1];
        @$client_id = explode('@', $config)[0];
    } elseif (substr($_POST['config'], 0, 9) === "trojan://") {
        // کانفیگ یک کانفیگ VLESS است
        $protocol = "trojan";
        $is_v2ray = 1;
    } else {
        // کانفیگ نامعتبر است
        $is_v2ray = 0;
    }
    if ($is_v2ray <> 1) {
        $message = 'کانفیگ ارسالی اشتباه است لطفا پس از بررسی مجدد کد را ارسال کنید';
    } else {
        $res = mysqli_query($conn, "SELECT * FROM `services` WHERE `client_id` = '$client_id'") or die(mysqli_error());
        if (mysqli_num_rows($res) == 0) {
            $message = 'سرویس شما یافت نشد لطفا کد کانفیگ صحیح را ارسال کنید.';
        } else {
            $service = mysqli_fetch_assoc($res);
            if ($service['status'] == 'active') {
                $rs = mysqli_query($conn, "SELECT * FROM `servers` WHERE `id` = '" . $service['server_id'] . "'") or die(throwSQLError(__FILE__, __LINE__, mysqli_error($conn)));
                $server = mysqli_fetch_assoc($rs);
                require_once 'xuiapi.php';
                $a = new xUiapi($server['address'] . ':' . $server['port'] . $server['root'], $server['username'], $server['password'], $server['type']);
                $client = $a->get_Client($service['client_id']);
                if ($client['success'] <> true) {
                    error_log("خطا در دریافت سرویس api: " . $client['msg'] . ' server: ' . $service['server_id'] . ' inbund: ' . $service['inbund_id'] . ' client: ' . $service['client_id']);
                    $info['status'] = 'غیرفعال';
                    $info['color'] = 'danger';
                    $message = 'سرویس شما یافت نشد لطفا با پشتیبانی تماس بگیرید.';
                } else {
                    $client = $client['obj'];
                    $iplimit = (isset($client['limitIp']) and $client['limitIp'] <> '0' and $client['limitIp'] <> '') ? $client['limitIp']  : 'نامحدود';
                    $expiryTime = ($client['expiryTime'] < 0) ? (abs($client['expiryTime']) / 86400000) . ' روز از اولین اتصال' : (($client['expiryTime'] > 0) ? jdate("H:i Y/m/d", intval($client['expiryTime'] / 1000), '', 'Asia/Tehran', 'en') . ' (' . ago_time($client['expiryTime'] / 1000) . ')' : (($client['expiryTime'] == 0) ? 'نامحدود' : 'نامشخص'));
                    $client['totalGB'] = ($client['totalGB'] == 'NAN' or $client['totalGB'] == 0) ? 'نامحدود' : formatBytes($client['totalGB']);

                    if (@$client['enable'] == true and isset($client['enable'])) {
                        $info['status'] = 'فعال';
                        $info['color'] = 'success';
                        // اگه سرور تانل تظیم بود آدرس آی پی کانفیگ رو تغییر بده
                        $server_ip = ($server['tunnel'] <> '0') ? $server['tunnel'] : $server['address'];

                        $cf_links = get_setting('cloudflare_links');
                        // اگه لینک تانل موجود بود لینک های کلادفلر رو نمایش نده
                        if (count($client['inbund']['externalProxy']) == 0 and $cf_links <> '0' and $cf_links <> '' and $server['tunnel'] == '0' and $client['inbund']['security'] <> 'reality' and $client['inbund']['host'] == '' and $client['inbund']['sni'] == '') {
                            $cf_links = explode("\n", get_setting('cloudflare_links'));
                            if (is_array($cf_links)) {
                                $i = 0;
                                foreach ($cf_links as $cf_link) {
                                    if ($cf_link == '0' or $cf_link == '') continue;
                                    $remark = (isset(explode('@', $cf_link)[1])) ? $service['name'] . ' ' . explode('@', $cf_link)[0] : $service['name'];
                                    $cf_link_link = (isset(explode('@', $cf_link)[1])) ? explode('@', $cf_link)[1] : explode('@', $cf_link)[0];
                                    $cf_link_link = preg_replace("/\r|\n/", "", $cf_link_link);

                                    // if is Grpc we can't use Random SNI
                                    $clean_address =  explode('.', $server_ip)[count(explode('.', $server_ip)) - 2] . '.' . explode('.', $server_ip)[count(explode('.', $server_ip)) - 1];
                                    $sni = ($client['inbund']["network"] <> 'grpc') ? generateRandomString() . '.' . $clean_address : $server_ip;

                                    $links[$i]['remark'] = $remark;
                                    $links[$i]['config'] = $a->get_config($client, $cf_link_link, $remark, $server_ip, $sni);

                                    $i++;
                                }
                            }
                        } else { //نمایش کانفیگ اصلی


                            $configs = $a->get_config($client, $server_ip, $client['inbund']['remark']);
                            if (is_array($configs)) {
                                $i = 0;
                                foreach ($configs as $config) {
                                    $links[$i]['remark'] = $service['name'];
                                    $links[$i]['config'] = $config;
                                    $i++;
                                }
                            } else {
                                $links[0]['remark'] = $service['name'];
                                $links[0]['config'] = $configs;
                            }
                        }
                    } else {
                        $info['status'] = 'غیرفعال';
                        $info['color'] = 'danger';
                        $message = 'سرویس شما یافت نشد لطفا با پشتیبانی تماس بگیرید.';
                    }
                }
            } else {
                $info['status'] = 'غیرفعال';
                $info['color'] = 'danger';
                $message = 'سرویس شما غیرفعال است لطفا سرویس خود را تمدید کنید';
            }
        }
    }
}

$file_names = array();
?>
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="Cache-control" content="no-cache">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>دریافت وضعیت سرویس</title>
    <link href="css/bootstrap.css" rel="stylesheet">
    <link href="css/reset.css" rel="stylesheet">
    <link href="css/main.css" rel="stylesheet">
    <!-- فایل CSS کتابخانه toastr -->
    <link href="https://cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/css/toastr.min.css" rel="stylesheet">
    <style>
        /* استایل های مخصوص موبایل */
        @media screen and (max-width: 767px) {
            .qr_image {
                display: flex;
                justify-content: center;
                align-items: center;
                max-width: 100%;
                max-height: 100%;
            }
        }

        /* استایل های مخصوص تبلت */
        @media screen and (min-width: 768px) and (max-width: 991px) {
            .qr_image {
                display: flex;
                justify-content: center;
                align-items: center;
                max-width: 100%;
                max-height: 100%;
            }
        }

        /* استایل های مخصوص لپتاپ */
        @media screen and (min-width: 992px) and (max-width: 1199px) {
            .qr_image {
                max-width: 70px;
            }
        }

        /* استایل های مخصوص کامپیوتر */
        @media screen and (min-width: 1200px) {
            .qr_image {
                max-width: 100px;
            }
        }

        #modal-container {
            position: fixed;
            top: 0;
            left: 0;
            width: 100%;
            height: 100%;
            background-color: rgba(0, 0, 0, 0.7);
            display: none;
            z-index: 999;
        }

        #modal-content {
            position: absolute;
            top: 50%;
            left: 50%;
            transform: translate(-50%, -50%);
            width: 90%;
            max-width: 800px;
            background-color: white;
            padding: 20px;
            box-sizing: border-box;
        }

        #modal-image {
            max-width: 100%;
            height: auto;
        }
    </style>
</head>

<body>
    <div class="container">
        <div class="row">
            <div class="col-md-12">
                <div class="main clearfix" style="border: 1px solid #ccc!important">
                    <div class="col-xs-12">
                        <h2 class="titleService" style="padding:20px;color: #000000;">دریافت و بررسی وضعیت سرویس</h2>
                    </div>
                    <div class="col-xs-12">
                        <div class="rightBox clearfix">
                            <div class="payForm col-xs-12">
                                <form method="post" action="" id="myForm">
                                    <div class="form-group">
                                        <label for="inputText">کد کانفیگ</label>
                                        <textarea class="form-control" id="inputText" name="config" rows="3" placeholder="لطفا کد کانفیگ vmess یا vless خود را اینجا وارد کنید" onkeydown="if (event.keyCode == 13) {document.getElementById('myForm').submit();}"></textarea>
                                    </div>
                                    <div class="form-group">
                                        <input type="hidden" name="csrf_token" value="<?php echo bin2hex(random_bytes(16)); ?>">
                                        <input type="submit" class="btn btn-primary" style="margin: 20px;" value="جستجو" />
                                        <a href="https://t.me/<?php echo getme(); ?>" class="btn btn-warning" style="margin: 20px;">خرید اشتراک</a>
                                    </div>
                                </form>
                                <br>
                                <?php if (!isset($message) and isset($_POST['config'])) { ?>
                                    <div class="card">
                                        <div class="card-body">
                                            <h5 class="card-title">اطلاعات سرویس</h5>
                                            <ul class="list-group">
                                                <li class="list-group-item list-group-item-<?php echo $info['color'] ?>">وضعیت: <?php echo $info['status']; ?></li>
                                                <li class="list-group-item list-group-item-light"> محدودیت اتصال: <?php echo $iplimit ?></li>
                                                <li class="list-group-item list-group-item-primary">حجم دانلود: <?php echo  formatBytes($client["down"]) ?></li>
                                                <li class="list-group-item list-group-item-light">حجم آپلود: <?php echo formatBytes($client["up"]) ?></li>
                                                <li class="list-group-item list-group-item-primary"> مجموع مصرف: <?php echo formatBytes($client["down"] + $client["up"]) ?></li>
                                                <li class="list-group-item list-group-item-light">حجم کل: <?php echo  $client['totalGB'] ?></li>
                                                <li class="list-group-item list-group-item-primary">تاریخ انقضا: <?php echo $expiryTime ?> </li>
                                                <br>
                                                <li class="list-group-item"><strong>سرویس ها: </strong>
                                                    <br><br>
                                                    <label for="">با کلیک روی هر سرویس بصورت خودکار کپی می شود</label>
                                                    <br><br>
                                                    <ul style="text-align: left;">
                                                        <?php
                                                        if (is_array($links)) {
                                                            foreach ($links as $link) {
                                                                $filename = 'qr_img_' . rand() . '.jpg';
                                                                $options = new QROptions;
                                                                $options->outputType = QROutputInterface::GDIMAGE_PNG;
                                                                $options->scale      = 20;
                                                                $qrcode = new QRCode($options);
                                                                $qrcode->render($link['config'], $filename);
                                                                echo '<img src="' . $script_path . $filename . '" alt="small image" class="qr_image" data-bs-toggle="modal" data-bs-target="#myModal" data-qr="' . $filename . '">';
                                                                echo '<li><b>' . $link['remark'] . '</b></li><br><li class="copyable-text">' . $link['config'] . "</li><br><hr>";
                                                                //@unlink($filename);
                                                                $file_names[] = $filename;
                                                            }
                                                        }
                                                        ?>
                                                    </ul>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                <?php } elseif (isset($message)) { ?>
                                    <div class="alert alert-danger" role="alert">
                                        <?php echo $message ?>
                                    </div>
                                <?php } ?>
                            </div>
                        </div>
                    </div>
                    <div class="modal fade" id="myModal" tabindex="-1">
                        <div class="modal-dialog">
                            <div class="modal-content pad table-responsive">
                                <div class="modal-header">
                                    <h5 class="modal-title">کد QR</h5>
                                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                                </div>
                                <div class="modal-body">
                                    <img style="max-width: 100%;" alt="qr" class="modal-qr" id="modal-qr" />
                                </div>
                                <div class="modal-footer">
                                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">بستن</button>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</body>
<!-- بارگیری کتابخانه‌ی jQuery -->
<script src="js/jquery-3.6.3.min.js"></script>
<!-- فایل JS کتابخانه toastr -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/js/toastr.min.js"></script>
<!-- Bootstrap 5 -->
<script src="js/bootstrap.bundle.min.js"></script>

<script>
    // پیدا کردن تمام المان های با کلاس copyable-text
    const copyableTexts = document.querySelectorAll('.copyable-text');
    // برای هر المان، یک رویداد کلیک اضافه کنید
    copyableTexts.forEach(text => {
        text.addEventListener('click', () => {
            // کپی کردن متن المان کلیک شده
            navigator.clipboard.writeText(text.innerText);
            // نمایش پیام موفقیت آمیز
            toastr.success('کپی شد!')
            // حذف پیام پس از 3 ثانیه
            setTimeout(() => {
                message.remove();
            }, 3000);
        });
    });
    $('#myModal').on('show.bs.modal', function(event) {
        var button = $(event.relatedTarget) // Button that triggered the modal
        var qr = button.data('qr') // Extract info from data-* attributes
        var modalimg = document.getElementById("modal-qr");
        modalimg.src = qr;
    });
</script>


<?php

sleep(5);
foreach ($file_names as $file) {
    unlink($file);
}
?>

</html>