

--
-- Table structure for table `admins`
--

CREATE TABLE `admins` (
  `id` int(11) NOT NULL,
  `username` text DEFAULT NULL,
  `password` text DEFAULT NULL,
  `email` text DEFAULT NULL,
  `mobile` text DEFAULT NULL,
  `created` bigint(20) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_persian_ci;

-- --------------------------------------------------------

--
-- Table structure for table `discounts`
--

CREATE TABLE `discounts` (
  `id` int(11) NOT NULL,
  `code` text NOT NULL,
  `percent` int(11) NOT NULL DEFAULT 0,
  `start_date` bigint(20) NOT NULL DEFAULT 0,
  `end_date` bigint(20) NOT NULL DEFAULT 0
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_persian_ci;

-- --------------------------------------------------------

--
-- Table structure for table `members`
--

CREATE TABLE `members` (
  `id` int(11) NOT NULL,
  `userid` bigint(50) NOT NULL,
  `username` text DEFAULT NULL,
  `step` text DEFAULT NULL,
  `previous_stage` text DEFAULT NULL,
  `use_test` int(11) NOT NULL DEFAULT 0,
  `fname` text DEFAULT NULL,
  `score` int(11) NOT NULL DEFAULT 0,
  `invitecode` bigint(20) NOT NULL DEFAULT 0,
  `status` text DEFAULT NULL,
  `mobile` text DEFAULT NULL,
  `mobile_verify` int(11) NOT NULL DEFAULT 0,
  `mobile_verify_code` bigint(20) NOT NULL DEFAULT 0,
  `mobile_verify_waiting` bigint(20) NOT NULL DEFAULT 0,
  `created` bigint(20) NOT NULL,
  `last_activity` bigint(20) NOT NULL,
  `banned` tinyint(4) NOT NULL DEFAULT 0,
  `seller` tinyint(4) NOT NULL DEFAULT 0,
  `is_admin` tinyint(4) NOT NULL DEFAULT 0
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_persian_ci;

-- --------------------------------------------------------

--
-- Table structure for table `options`
--

CREATE TABLE `options` (
  `meta_name` varchar(200) NOT NULL,
  `meta_value` text DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_persian_ci;

--
-- Dumping data for table `options`
--

INSERT INTO `options` (`meta_name`, `meta_value`) VALUES
('next_rates_check', '0'),
('next_sevices_check', '0'),
('USD_Rate', '0'),
('TRX_Rate', '0'),
('next_services_check', '0');

-- --------------------------------------------------------

--
-- Table structure for table `payments`
--

CREATE TABLE `payments` (
  `id` int(11) NOT NULL,
  `userid` bigint(20) NOT NULL,
  `service_id` int(11) DEFAULT 0,
  `price` text CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `final_price` text DEFAULT NULL,
  `status` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'pending',
  `tracking_code` text DEFAULT NULL,
  `paymentmethod` text DEFAULT NULL,
  `pay_for` text DEFAULT NULL,
  `service` text DEFAULT NULL,
  `created` bigint(20) NOT NULL,
  `transaction_id` varchar(50) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_persian_ci;

-- --------------------------------------------------------

--
-- Table structure for table `security`
--

CREATE TABLE `security` (
  `id` int(11) NOT NULL,
  `captcha_type` text DEFAULT NULL,
  `recaptcha_sitekey` text DEFAULT NULL,
  `recaptcha_secretkey` text DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_persian_ci;

--
-- Dumping data for table `security`
--

INSERT INTO `security` (`id`, `captcha_type`, `recaptcha_sitekey`, `recaptcha_secretkey`) VALUES
(1, 0, NULL, NULL);

-- --------------------------------------------------------

--
-- Table structure for table `send_queue`
--

CREATE TABLE `send_queue` (
  `id` int(11) NOT NULL,
  `user_id` bigint(20) NOT NULL,
  `edit_message_id` bigint(20) NOT NULL DEFAULT 0,
  `type` varchar(50) NOT NULL DEFAULT 'text',
  `text` varchar(5000) DEFAULT NULL,
  `entities` varchar(2000) DEFAULT NULL,
  `message_id` bigint(20) NOT NULL DEFAULT 0,
  `file_id` bigint(20) NOT NULL DEFAULT 0,
  `offset` bigint(20) NOT NULL DEFAULT 0,
  `status` varchar(50) NOT NULL DEFAULT 'pending',
  `all_users` bigint(20) NOT NULL DEFAULT 0,
  `send_ok` bigint(20) NOT NULL DEFAULT 0,
  `send_nok` bigint(20) NOT NULL DEFAULT 0
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_persian_ci;

-- --------------------------------------------------------

--
-- Table structure for table `servers`
--

CREATE TABLE `servers` (
  `id` int(11) NOT NULL,
  `name` text DEFAULT NULL,
  `address` varchar(1000) DEFAULT NULL,
  `ip` text DEFAULT NULL,
  `port` int(11) DEFAULT 80,
  `root` text DEFAULT NULL,
  `username` text DEFAULT NULL,
  `password` text DEFAULT NULL,
  `type` varchar(100) DEFAULT 'old',
  `limitinbund` int(11) NOT NULL DEFAULT 0,
  `tunnel` varchar(200) DEFAULT '0',
  `plans` varchar(10000) DEFAULT NULL,
  `sale` text DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_persian_ci;

-- --------------------------------------------------------

--
-- Table structure for table `services`
--

CREATE TABLE `services` (
  `id` int(11) NOT NULL,
  `user_id` bigint(20) DEFAULT NULL,
  `name` text CHARACTER SET utf8mb4 COLLATE utf8mb4_persian_ci DEFAULT NULL,
  `status` varchar(50) NOT NULL DEFAULT 'active',
  `server_id` int(11) DEFAULT NULL,
  `inbund_id` int(11) DEFAULT NULL,
  `client_id` text DEFAULT NULL,
  `inbund_name` text DEFAULT NULL,
  `protocol` text DEFAULT NULL,
  `network` text DEFAULT NULL,
  `plan_id` int(11) DEFAULT NULL,
  `days` int(11) DEFAULT NULL,
  `bw` int(11) DEFAULT NULL,
  `created` bigint(20) NOT NULL,
  `renewsent` int(11) NOT NULL DEFAULT 0,
  `renewGB` bigint(20) NOT NULL DEFAULT 0,
  `renewTime` bigint(20) NOT NULL DEFAULT 0
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;

-- --------------------------------------------------------

--
-- Table structure for table `settings`
--

CREATE TABLE `settings` (
  `id` int(11) NOT NULL DEFAULT 1,
  `channel` text CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `channel_text` text CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `complete_profile_text` text CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `welcome_text` text CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `compelete_info` text CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `rules_text` text NOT NULL,
  `help_text` text CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `referal_text` text DEFAULT NULL,
  `contactus_text` text CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `bot_token` text CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `script_path` text CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `lic_key` varchar(300) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `runtime` int(11) NOT NULL DEFAULT 0,
  `active_gateways` text CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `zibal_api` text CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `card2card_text` text CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `nowpayments_api` text CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `acc_buy` tinyint(4) NOT NULL DEFAULT 1,
  `acc_renew` tinyint(4) NOT NULL DEFAULT 1,
  `acc_change` int(11) NOT NULL DEFAULT 1,
  `sublink` tinyint(4) DEFAULT 0,
  `acc_test` tinyint(4) NOT NULL DEFAULT 0,
  `acc_edittest` tinyint(4) NOT NULL DEFAULT 0,
  `usd_price` bigint(20) DEFAULT NULL,
  `membership_commission` int(11) DEFAULT 0,
  `cloudflare_links` varchar(500) DEFAULT '0',
  `alert_renew_bw` tinyint(4) NOT NULL DEFAULT 2,
  `alert_renew_time` tinyint(4) NOT NULL DEFAULT 5,
  `del_service_after_days` tinyint(4) NOT NULL DEFAULT 5,
  `reset_bw_on_renew` tinyint(4) NOT NULL DEFAULT 0,
  `reset_time_on_renew` tinyint(4) NOT NULL DEFAULT 0
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_persian_ci;

--
-- Dumping data for table `settings2`
--

INSERT INTO `settings` (`id`, `channel`, `channel_text`, `complete_profile_text`, `welcome_text`, `compelete_info`, `rules_text`, `help_text`, `referal_text`, `contactus_text`, `bot_token`, `script_path`, `lic_key`, `runtime`, `active_gateways`, `zibal_api`, `card2card_text`, `nowpayments_api`, `acc_buy`, `acc_renew`, `acc_change`, `sublink`, `acc_test`, `acc_edittest`, `usd_price`, `membership_commission`, `cloudflare_links`, `alert_renew_bw`, `alert_renew_time`, `del_service_after_days`, `reset_bw_on_renew`, `reset_time_on_renew`) VALUES
(1, '0', 'برای ادامه کار با ربات لطفا در کانال زیر عضو شوید', 'پروفایلت رو تکمیل کن', 'کاربر گرامی خوش اومدی 😊\nاگه قصد خرید سورس این ربات را دارید فقط با آیدی @x2ray_bot_support \nدر ارتباط باشید ', 'پروفایل شما تکمیل شد', 'متن قوانین', 'متن راهنما', 'در ربات زیر عضو شو', 'اطلاعات تماس با ما', '0', '0', NULL, 0, '[\"nowpayments\",\"perfectmoney\"]', 'zibal', 'شماره کارت تست:\n1234-1234-1234-1234', 'JV7ES0Z-XRBM3FS-H8HM5N6-GSK4HAQ', 1, 1, 1, 1, 1, 0, 50000, 5, '0', 5, 5, 5, 0, 0);

-- --------------------------------------------------------

--
-- Table structure for table `support`
--

CREATE TABLE `support` (
  `id` int(11) NOT NULL,
  `user_id` bigint(20) DEFAULT NULL,
  `agent_id` bigint(20) DEFAULT NULL,
  `subject` text DEFAULT NULL,
  `content` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_polish_ci DEFAULT NULL,
  `status` text DEFAULT NULL,
  `updated` bigint(20) DEFAULT NULL,
  `created` bigint(20) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_persian_ci;

-- --------------------------------------------------------

--
-- Table structure for table `support_comments`
--

CREATE TABLE `support_comments` (
  `id` int(11) NOT NULL,
  `ticket_id` int(11) NOT NULL,
  `user_id` bigint(20) DEFAULT NULL,
  `agent_id` bigint(20) DEFAULT NULL,
  `content` text DEFAULT NULL,
  `updated` bigint(20) DEFAULT NULL,
  `created` bigint(20) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_persian_ci;

--
-- Indexes for dumped tables
--

--
-- Indexes for table `admins`
--
ALTER TABLE `admins`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `discounts`
--
ALTER TABLE `discounts`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `members`
--
ALTER TABLE `members`
  ADD PRIMARY KEY (`id`),
  ADD UNIQUE KEY `id` (`id`);

--
-- Indexes for table `options`
--
ALTER TABLE `options`
  ADD PRIMARY KEY (`meta_name`);

--
-- Indexes for table `payments`
--
ALTER TABLE `payments`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `security`
--
ALTER TABLE `security`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `send_queue`
--
ALTER TABLE `send_queue`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `servers`
--
ALTER TABLE `servers`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `services`
--
ALTER TABLE `services`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `settings`
--
ALTER TABLE `settings`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `support`
--
ALTER TABLE `support`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `support_comments`
--
ALTER TABLE `support_comments`
  ADD PRIMARY KEY (`id`);

--
-- AUTO_INCREMENT for dumped tables
--

--
-- AUTO_INCREMENT for table `admins`
--
ALTER TABLE `admins`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `discounts`
--
ALTER TABLE `discounts`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `members`
--
ALTER TABLE `members`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `payments`
--
ALTER TABLE `payments`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `security`
--
ALTER TABLE `security`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `send_queue`
--
ALTER TABLE `send_queue`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `servers`
--
ALTER TABLE `servers`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `services`
--
ALTER TABLE `services`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `support`
--
ALTER TABLE `support`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `support_comments`
--
ALTER TABLE `support_comments`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
COMMIT;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
