<?php

use chillerlan\QRCode\{QRCode, QROptions};
use chillerlan\QRCode\Common\EccLevel;
use chillerlan\QRCode\Output\{QROutputAbstract, QROutputInterface};

require_once 'vendor/autoload.php';

require_once 'config.php';
require_once 'telegram.php';
require_once 'functions.php';

$keyboard = json_encode(array(
    'inline_keyboard' => array(
        array(

            array("text" => "🔁 تمدید سرویس", "callback_data" => "renew_acc"),
            array("text" => "🛍 خرید سرویس", "callback_data" => "buy_acc")
        ),
        array(
            array("text" => "👤 حساب کاربری", "callback_data" => "account"),
            array("text" => "🔑 سرویس های من", "callback_data" => "my_services")
        ),
        array(
            array("text" => "💎 کیف پول من", "callback_data" => "my_score"),
            array("text" => "💎 دریافت امتیاز", "callback_data" => "get_score"),
        ),
        array(
            array("text" => "🤔 راهنما", "callback_data" => "help"),
            array("text" => "🗒 قوانین", "callback_data" => "rules")
        ),
        array(
            array("text" => "⏰ سرویس تست", "callback_data" => "test_service"),
            array("text" => "☎️ پشتیبانی", "callback_data" => "support")
        ),
    )
));

$keyboard_admin = json_encode(array(
    'inline_keyboard' => array(
        array(
            array("text" => "🌐 سرور ها", "callback_data" => "servers")
        ),
        array(
            array("text" => "📣 پیام عمومی", "callback_data" => "public_message"),
            array("text" => "📊 آمار", "callback_data" => "status")
        ),
        array(
            array("text" => "🧮 کدهای تخفیف", "callback_data" => "discount_codes"),
            array("text" => "👥 کاربران", "callback_data" => "members"),

        ),
        array(array("text" => "⚙️ تنظیمات", "callback_data" => "settings")),
    )
));


$payment_success = 0;

if (isset($_POST['order_id'])) {

    $order_id = mysqli_real_escape_string($conn, $_POST['order_id']);
    $tracking_code = mysqli_real_escape_string($conn, $_POST['tracking_code']);


    //get info from payments
    $res = mysqli_query($conn, "SELECT * FROM `payments` WHERE `id` = '$order_id'") or die(throwSQLError(__FILE__, __LINE__, mysqli_error($conn)));
    if (mysqli_num_rows($res) == 0) {
        $err = "سفارش شما پیدا نشد";
        goto showHTML;
    }
    $row = mysqli_fetch_assoc($res);
    $order_id   = $row['id'];
    $service_id = $row['service_id'];
    $Amount     = $row['final_price'];
    $gateway    = $row['paymentmethod'];
    $o_user_id  = $row['userid'];
    $o_status   = $row['status'];
    $pay_for    = $row['pay_for'];
    $service    = json_decode($row['service'], true);

    if ($o_status == 'pending') {

        if (!empty($row['tracking_code']) && !empty($tracking_code) && $row['tracking_code'] == $tracking_code) {

            $payment_success = 1;

            if (get_user($o_user_id)['invitecode'] > 1 and get_setting('membership_commission') > 0) {
                $commission = (get_setting('membership_commission') / 100) * $Amount;
                mysqli_query($conn, "UPDATE `members` SET `score` = `score` + '$commission' WHERE `userid` = '" . get_user($o_user_id)['invitecode'] . "'") or die(throwSQLError(__FILE__, __LINE__, mysqli_error($conn)));
                sendmessage2(get_user($o_user_id)['invitecode'], "کاربر گرامی شما $commission تومان بابت خرید یکی از زیرمجموعه هایتان بدست آوردید", $keyboard);
            }

            if ($pay_for == 'add_funds') {

                //set status to success
                mysqli_query($conn, "UPDATE `payments` SET `status` = 'completed' WHERE `id` = '$order_id'") or die(throwSQLError(__FILE__, __LINE__, mysqli_error($conn)));
                mysqli_query($conn, "UPDATE `members` SET `score` = `score` + '$Amount' WHERE `userid` = '$o_user_id'") or die(throwSQLError(__FILE__, __LINE__, mysqli_error($conn)));
                sendMessage2($o_user_id, "⭕️شارژ کیف پول\n✅ پرداخت موفق\nمبلغ: `" . number_format($Amount) . "` تومان\nشماره سفارش: `$order_id`\n.", $keyboard, 'markdown');
                sendMessage2($admins[0], "✅ *پرداخت موفق*\n*کاربر:* [$o_user_id](tg://user?id=$o_user_id)  \n *مبلغ:* `" . number_format($Amount) . " تومان`\n*کد پیگیری:* `" . $tracking_code . "`\n*شماره سفارش:* `$order_id`\n*درگاه پرداخت:* `$gateway`\n*پرداخت برای:* شارژ کیف پول\n.", $keyboard_admin, 'markdown');
            } else {

                sendMessage2($o_user_id, "✅ پرداخت موفق\nمبلغ: `" . number_format($Amount) . " تومان`\nکد پیگیری: `" . $tracking_code . "`\nشماره سفارش: `$order_id`\n.", $keyboard, 'markdown');

                $rs = mysqli_query($conn, "SELECT * FROM `servers` WHERE `id` = '" . $service['server_id'] . "'") or die(throwSQLError(__FILE__, __LINE__, mysqli_error($conn)));
                $server = mysqli_fetch_assoc($rs);
                $server_name = $server['name'];

                //دریافت پلن های سرور انتخابی
                $plans = json_decode($server['plans'], true);
                $plan = $plans[$service['plan_id']];
                $plan_name = $plan['name'];
                $days = $plan['days'];
                $bw = $plan['bw'];
                $ip_limit = $plan['ip'];

                sendMessage2($admins[0], "✅ *پرداخت موفق*\n*کاربر:* [$o_user_id](tg://user?id=$o_user_id)  \n *مبلغ:* `" . number_format($Amount) . " تومان`\n*کد پیگیری:* `" . $tracking_code . "`\n*شماره سفارش:* `$order_id`\n*درگاه پرداخت:* `$gateway`\n*پلن:* $plan_name\n*سرور: *$server_name\n.", $keyboard_admin, 'markdown');


                require_once 'xuiapi.php';
                $xuiapi = new xUiapi($server['address'] . ':' . $server['port'] . $server['root'], $server['username'], $server['password'], $server['type']);

                $pay_opration = 'create';
                //اگه سرویس آیدی موجود بود باید تمدید بشه و اگه موجود نبود خرید جدید محسوب میشه
                if ($service_id <> '' and $service_id <> 0) {
                    $rs = mysqli_query($conn, "SELECT * FROM `services` WHERE `id` = '$service_id'") or die(throwSQLError(__FILE__, __LINE__, mysqli_error($conn)));
                    if (mysqli_num_rows($rs) > 0) {

                        $rw = mysqli_fetch_assoc($rs);
                        $client_id = $rw['client_id'];
                        $pay_opration = 'renew';

                        // دریافت کلاینت برای بررسی حجم و زمان باقیمانده
                        $res = $xuiapi->Get_Client($client_id);
                        if (@$res['success'] <> true) {
                            $res = $xuiapi->Get_Client($client_id);
                        }
                        if (@$res['success'] <> true) {
                            $errorMessage = "در ایجاد سرویس  خطایی رخ داد. مبلغ پرداخت شده به کیف پول شما اضافه شد\nلطفا خرید خود را مجدد از طریق کیف پول انجام دهید";
                            sendmessage2($o_user_id, "در ایجاد سرویس  خطایی رخ داد. مبلغ پرداخت شده به کیف پول شما اضافه شد\nلطفا خرید خود را مجدد از طریق کیف پول انجام دهید", $keyboard);
                            mysqli_query($conn, "UPDATE `members` SET `score` = `score` + '$Amount' WHERE `userid` = '$o_user_id'") or die(throwSQLError(__FILE__, __LINE__, mysqli_error($conn)));
                            sendMessage2($admins[0], "خطا در دریافت کلاینت در پرداخت آنلاین:\n" . @$res['msg']);
                            error_log("error on addclient on card2card payment:" . "\nclient ID: " . $client_id . "\nuser: $o_user_id\nserver: " . $server['id'] . "\n");
                            goto showHTML;
                        }

                        $client = $res['obj'];
                        $client['expiryTime'] /= 1000;

                        //اگر ریست فعال بود یا حجم فعلی 0 بود از زمان فعلی حساب کن
                        // در غیر اینصورت با روز قبلی جمع بشه
                        $new_expire = (get_setting('reset_time_on_renew') or $client['expiryTime'] == 0) ? time() + ($days * 86400) : $client['expiryTime'] + ($days * 86400);
                        // اگر پلن ویرایش شده بود و حجم یا تایم پلن نامحدود بود باید جایگزین بشه و به حجم یا تایم قبلی سرویس اضافه نشه
                        $new_expire = ($days == 0) ? $days : $new_expire;
                        // اگر کلاینت منقضی شده بود از زمان فعلی حساب کن
                        $new_expire = ($client['expiryTime'] > 0 and $client['expiryTime'] < time()) ? time() + ($days * 86400) : $new_expire;

                        // اگر ریست فعال بود یا حجم فعلی 0 بود یا حجم جدید 0 بود حجم جدید جازگزین بشه
                        $replace_bw = (get_setting('reset_bw_on_renew') or $client['totalGB'] == 0 or $bw == 0) ? true : false;

                        //اگر حجم قبلی 0 باشه و حجم جدید 0 نباشه ترافیک ریست بشه
                        // اگر حجم جدید نامحدود بود یا از تنظیمات قرار به ریست بود باید ریست انجام بشه
                        if ($replace_bw) {
                            $res = $xuiapi->resetClientTraffic($client_id);
                            if (!$res['success'])
                                $res = $xuiapi->resetClientTraffic($client_id);

                            if ($res['success'] <> true) {
                                $errorMessage = "در ایجاد سرویس  خطایی رخ داد. مبلغ پرداخت شده به کیف پول شما اضافه شد\nلطفا خرید خود را مجدد از طریق کیف پول انجام دهید";
                                sendmessage2($o_user_id, "در ایجاد سرویس  خطایی رخ داد. مبلغ پرداخت شده به کیف پول شما اضافه شد\nلطفا خرید خود را مجدد از طریق کیف پول انجام دهید", $keyboard);
                                mysqli_query($conn, "UPDATE `members` SET `score` = `score` + '$Amount' WHERE `userid` = '$o_user_id'") or die(throwSQLError(__FILE__, __LINE__, mysqli_error($conn)));
                                sendMessage2($admins[0], "خطا در ریست ترافیک در تمدید با درگاه آنلاین :\n" . $res['msg']);
                                error_log('Error to resetClientTraffic on Update service by Online gateway');
                                goto showHTML;
                            }
                        }

                        // تمدید کلاینت
                        $res = $xuiapi->EditClient($client_id, (float)$bw, $new_expire, $ip_limit, null, $replace_bw);
                        if (!$res['success']) {
                            $res = $xuiapi->EditClient($client_id, (float)$bw, $new_expire, $ip_limit, null, $replace_bw);
                        }
                    }
                }

                //ایجاد کلاینت
                if ($pay_opration == 'create') {
                    //ایجاد کلاینت جدید
                    $client_id = guidv4();
                    $res = $xuiapi->AddClient($service['inbund_id'], $client_id, time() . '-' . $row['userid'] . '.com', $ip_limit, (int)$bw, time() + ($days * 86400));
                    if (@$res['success'] <> true) {
                        $res = $xuiapi->AddClient($service['inbund_id'], $client_id, time() . '-' . $row['userid'] . '.com', $ip_limit, (int)$bw, time() + ($days * 86400));
                    }
                }

                if ($res['success'] <> true) {
                    $errorMessage = "در ایجاد سرویس  خطایی رخ داد. مبلغ پرداخت شده به کیف پول شما اضافه شد\nلطفا خرید خود را مجدد از طریق کیف پول انجام دهید";
                    sendmessage2($o_user_id, "در ایجاد سرویس  خطایی رخ داد. مبلغ پرداخت شده به کیف پول شما اضافه شد\nلطفا خرید خود را مجدد از طریق کیف پول انجام دهید");
                    mysqli_query($conn, "UPDATE `members` SET `score` = `score` + '$Amount' WHERE `userid` = '$o_user_id'") or die(throwSQLError(__FILE__, __LINE__, mysqli_error($conn)));
                    goto showHTML;
                } else {

                    $client = $xuiapi->get_Client($client_id);
                    if (@$client['success'] <> true) {
                        $client = $xuiapi->get_Client($client_id);
                    }

                    if ($client['success'] <> true) {
                        sendMessage2($admins[0], "خطا در دریافت کانفیگ پس از پرداخت آنلاین\n\nخطا:\n" . $client['msg'] . "مشتری: $o_user_id \n\nآیدی کلاینت کانفیگ: $client_id");
                        sendMessage2($o_user_id, "سرویس شما ایجاد/تمدید شد اما در دریافت سرویس مشکلی رخ داد. لطفا از بخش سیرویس های من اطلاعات سرویس خود را مشاهده کنید");
                        error_log('Error to get client in receipt page : ' . json_encode($client));
                    } else {

                        $client = $client['obj'];

                        $iplimit = (isset($client['limitIp']) and $client['limitIp'] <> '0' and $client['limitIp'] <> '') ? $client['limitIp']  : 'نامحدود';
                        $expiryTime = ($client['expiryTime'] <> '' or $client['expiryTime'] > 0) ? ago_time($client['expiryTime'] / 1000)  : 'نامحدود';
                        $client['enable'] = ($client['enable']) ? '✅' : '❌';
                        $client['totalGB'] = ($client['totalGB'] == 'NAN') ? 'نامحدود' : formatBytes($client['totalGB']);


                        if ($pay_opration == 'create') {

                            mysqli_query($conn, "INSERT INTO `services`(`user_id`, `name`, `server_id`, `inbund_id`, `client_id`, `inbund_name`, `protocol`, `network`, `plan_id`, `days`, `bw`, `created`) VALUES ('" . $row['userid'] . "','" . $client['inbund']['remark'] . "','" . $service['server_id'] . "','" . $service['inbund_id'] . "','$client_id','" . $client['inbund']['remark'] . "','" . $client['inbund']['protocol'] . "','" . $client['inbund']['network'] . "','" . $service['plan_id'] . "','$days','$bw','" . time() . "')") or die(throwSQLError(__FILE__, __LINE__, mysqli_error($conn)));
                            $res = mysqli_query($conn, "SELECT `id` FROM `services` ORDER BY `id` DESC LIMIT 1") or (throwSQLError(__FILE__, __LINE__, mysqli_error($conn)));
                            $row = mysqli_fetch_assoc($res);
                            $service_id = $row['id'];
                            // ویرایش / تمدید کلاینت
                        } elseif ($pay_opration == 'renew') {
                            mysqli_query($conn, "UPDATE `services` SET `status` = 'active', `renewGB` = 0, `renewTime` = 0, `renewsent` = 0, `plan_id` = '" . $service['plan_id'] . "' , `days` = `days` + '$days' , `bw` = `bw` + '$bw' , `created` = '" . time() . "' WHERE `id` = '$service_id'") or die(throwSQLError(__FILE__, __LINE__, mysqli_error($conn)));
                        }

                        //set status to success
                        mysqli_query($conn, "UPDATE `payments` SET `status` = 'completed',`tracking_code` = '" . $tracking_code . "' , `service_id` = '$service_id' WHERE `id` = '$order_id'") or die(throwSQLError(__FILE__, __LINE__, mysqli_error($conn)));

                        $config = '';
                        // اگه سرور تانل تظیم بود آدرس آی پی کانفیگ رو تغییر بده
                        $server_ip = ($server['ip'] <> '0' and $client['inbund']['security'] == 'reality') ? $server['ip'] : $server['address'];
                        $server_ip = ($server['tunnel'] <> '0') ? $server['tunnel'] : $server_ip;

                        $cf_links = get_setting('cloudflare_links');

                        // اگه تانل فعال باشه و یا کانفیگ ریلیتی باشه و یا host یا sni تنظیم شده باشه از کلودفلر استفاده نمیشه
                        if (count($client['inbund']['externalProxy']) == 0 and $cf_links <> '0' and $cf_links <> '' and $server['tunnel'] == '0' and $client['inbund']['security'] <> 'reality' and $client['inbund']['host'] == '' and $client['inbund']['sni'] == '') {
                            $config = '';
                            $cf_links = explode("\n", $cf_links);
                            if (is_array($cf_links)) {
                                foreach ($cf_links as $cf_link) {

                                    if ($cf_link == '0' or $cf_link == '') continue;

                                    if (strlen($config) > 3300) {
                                        sendMessage2($o_user_id, "*کانفیگ های سرویس شما:*\n\n" . fixMarkdown($config), false, 'markdown');
                                        $config = '';
                                    }

                                    // if CF link have name the name added after config name
                                    $remark = (isset(explode('@', $cf_link)[1])) ? $client['inbund']['remark'] . ' ' . explode('@', $cf_link)[0] : $service['name'];
                                    // if CF links have name link is in section 2 else link is in section 1
                                    $cf_link_link = (isset(explode('@', $cf_link)[1])) ? explode('@', $cf_link)[1] : explode('@', $cf_link)[0];
                                    $cf_link_link = preg_replace("/\r|\n/", "", $cf_link_link);

                                    // if is Grpc we can't use Random SNI
                                    $clean_address =  explode('.', $server_ip)[count(explode('.', $server_ip)) - 2] . '.' . explode('.', $server_ip)[count(explode('.', $server_ip)) - 1];
                                    $sni = ($client['inbund']["network"] <> 'grpc') ? generateRandomString() . '.' . $clean_address : $server_ip;

                                    $config = $config . "\n\n$remark`\n" . $xuiapi->get_config($client, $cf_link_link, $remark, $server_ip, $sni) . "`";
                                }
                            }
                            sendmessage2($o_user_id, "*کانفیگ های سرویس شما:*\n\n" . ($config), false, 'markdown');
                            $config = '';
                        } else {

                            $configs = $xuiapi->get_config($client, $server_ip);

                            $config = '';
                            $qr_config = '';

                            foreach ($configs as $config1) {
                                $config = $config . "`" . $config1 . "`\n\n";
                                $qr_config = $qr_config . $config1 . "\n";
                            }


                            if (count($client['inbund']['externalProxy']) <= 3) {
                                // ایجاد QR کد
                                $filename = time() . '_config.jpg';
                                $options = new QROptions;
                                $options->outputType = QROutputInterface::GDIMAGE_PNG;
                                $options->scale = 20;
                                $qrcode = new QRCode($options);
                                $qrcode->render($qr_config, $filename);

                                sendPhoto2($o_user_id, $script_path . $filename);
                                unlink($filename);
                            }
                        }



                        $txt =
                            "🔰 *وضعیت:* " . $client["enable"] .
                            "\n📈 *مصرف:* " . formatBytes($client["down"] + $client["up"]) . ' از ' . $client["totalGB"] .
                            "\n📥 *دانلود:* " . formatBytes($client["down"]) .
                            "\n📤 *آپلود:* " . formatBytes($client["up"]) .
                            "\n🖥 *محدودیت آی پی:* " . $iplimit .
                            "\n⏰ *تاریخ انقضا:* " . $expiryTime .
                            "\n\n" . $config;


                        $key_mng_service = json_encode(array(
                            'inline_keyboard' => array(
                                array(array("text" => "🔙 بازگشت", "callback_data" => "my_services")),
                                array(
                                    array("text" => "✏️ تغییر نام", "callback_data" => "rename_service_$service_id"),
                                    array("text" => "🔰 اطلاعات سرویس", "callback_data" => "myservice_$service_id")
                                ),
                                array(
                                    array("text" => "⚙️ تغییر سرویس", "callback_data" => "change_service_$service_id"),
                                    array("text" => "🔄 تمدید سرویس", "callback_data" => "renew_service_$service_id")
                                ),
                            )
                        ));

                        if (get_setting('sublink') == 1) {
                            sendMessage2($o_user_id, "$txt\n🌐 لینک هوشمند این سرویس :\n" . $script_path . "api.php?&ser=" . $client["id"] . "\n.", $key_mng_service, 'markdown');
                        } else {
                            sendMessage2($o_user_id, "$txt\n.", $key_mng_service, 'markdown');
                        }
                    }
                }
            }
        } else {
            $err = "سفارش قبلا پرداخت شده.";
        }
    }
}

if (@isset($_POST["description"])) $err = "\n" . $_POST["description"];

showHTML:
?>



<html>

<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>نتیجه پرداخت</title>
    <link href="css/bootstrap.css" rel="stylesheet">
    <link href="css/reset.css" rel="stylesheet">
    <link href="css/main.css" rel="stylesheet">
    <link rel="icon" href="Money.png" type="image/png" sizes="16x16">

</head>

<body>
    <div class="container">
        <div class="row">
            <div class="col-xs-1 col-sm-1"></div>
            <div class="col-9">
                <div class="main clearfix" style="border: 1px solid #ccc!important; margin-top: 100px;">
                    <div class="col-12">
                        <h2 class="titleService" style="background-image: url('Money.png');">نتیجه پرداخت</h2>
                    </div>
                    <div class="col-12">
                        <div class="rightBox clearfix">
                            <div class="payForm col-xs-12">
                                <?php if ($payment_success == '1') { ?>
                                    <hr>
                                    <label style="font-size: larger;" class="col-sm-12 col-xs-12 col-md-12 control-label hidden-sm">وضعیت پرداخت: <small style="color: #00bb00;">موفق</small></label>
                                    <br>
                                    <hr>
                                    <label style="font-size: larger;" class="col-sm-12 col-xs-12 col-md-12 control-label hidden-sm">مبلغ: <small><?php echo number_format($Amount); ?> تومان</small></label>
                                    <br>
                                    <hr>
                                    <label style="font-size: larger;" class="col-sm-12 col-xs-12 col-md-12 control-label hidden-sm">کد پیگیری: <small><?php echo $_POST["tracking_code"]; ?></small></label>
                                    <br>
                                    <hr>
                                    <label style="font-size: larger;" class="col-sm-12 col-xs-12 col-md-12 control-label hidden-sm">شماره سفارش : <small><?php echo $order_id; ?></small></label>

                                    <?php if (isset($errorMessage)) {
                                        echo '<br>
                                    <hr>
                                    <label style="font-size: larger;" class="col-sm-12 col-xs-12 col-md-12 control-label hidden-sm">خطا: <small>' . $errorMessage . '</small></label>';
                                    } ?>
                                <?php } else { ?>
                                    <hr>
                                    <label style="font-size: larger;" class="col-sm-12 col-xs-12 col-md-12 control-label hidden-sm">وضعیت پرداخت: <small style="color: red;">ناموفق</small></label>
                                    <br>
                                    <hr>
                                    <label style="font-size: larger;" class="col-sm-12 col-xs-12 col-md-12 control-label hidden-sm">خطا: <small><?php echo @$err; ?></small></label>
                                    <br>
                                    <hr>
                                    <label style="font-size: larger;" class="col-sm-12 col-xs-12 col-md-12 control-label hidden-sm">شماره سفارش : <small><?php echo @$order_id; ?></small></label>
                                <?php } ?>
                            </div>
                        </div>
                    </div>

                </div>
            </div>
            <div class="col-xs-1 col-sm-1"></div>
        </div>
    </div>

</body>

</html>